\ Open Memory Test Language parser
\
\ Copyright 2006 Dennis Ruffer (druffer@worldnet.att.net)
\
\     This program is free software; you can redistribute it and/or modify
\     it under the terms of the GNU General Public License as published by
\     the Free Software Foundation; either version 2 of the License, or
\     (at your option) any later version.
\
\     This program is distributed in the hope that it will be useful,
\     but WITHOUT ANY WARRANTY; without even the implied warranty of
\     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
\     GNU General Public License for more details.
\
\     You should have received a copy of the GNU General Public License
\     along with this program; if not, write to the Free Software
\     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
\
\ Concepts translated from the a lex & yacc front-end to:
\
\ Ad J. van de Goor, Aad Offerman, and Ivo Schanstra:
\ Towards a Uniform Notation for Memory Tests
\ presented at the European Design & Test Conference and Exhibition 96
\
\ In here you can find a predecessor to the language above that is much more
\ limited (more like an extension to the March test notation) and thus
\ much more cleaner.
\
\ Memory Test Verification and Generation
\  Copyright 1995, A. Offerman (offerman@einstein.et.tudelft.nl),
\                  H.I. Schanstra (ivo@duteca.et.tudelft.nl),
\                  Section Computer Architecture & Digital Systems,
\                  Department of Electrical Engeneering,
\                  Delft University of Technology, The Netherlands
\  All rights reserved
\
\ http://www.offerman.net/memory/mtl.tgz

require ../ffl/stc.fs
require Array_operation.fth

struct: Chip_operation
    Core_operation: chip_core_operation
	    State_mask: chip_data			\ a word of length B, defining a to-be-written word
               int: row_index
               int: row_address
               int: column_index
               int: column_address
;struct

: Chip_operation_vector:   cell: ;		\ Vectors per port containing Chip_operation(s)

: .chip_operation ( a -- )   cr
	dup row_address ?
	dup column_address ?
	dup chip_core_operation c@ .core_operation
	chip_data dup @ ?dup if
		base @ >r 2 base !
		." = " swap vsize dup >r c@-le
		r@ 4 <= if  0  then  <#  r> 0 do
			# # # # # # # #
		loop  #> type  2 spaces
		r> base !
	else  drop  then
;

struct: Chip_process
					cell: time_operation
					cell: process_index
					char: 2_dimensions
					char: swapped_dimensions
					char: outer_backwards
					char: inner_backwards
					cell: row_increment
					cell: column_increment
					cell: row_exclusion
					cell: column_exclusion
   Chip_operation_vector: chip_operation_list
;struct

variable chip_processes   0 chip_processes !
variable chip_process#    0 chip_process# !

: chip_processing ( -- a )   chip_processes chip_process# @ [v] ;
