\ Open Memory Test Language parser
\
\ Copyright 2006 Dennis Ruffer (druffer@worldnet.att.net)
\
\     This program is free software; you can redistribute it and/or modify
\     it under the terms of the GNU General Public License as published by
\     the Free Software Foundation; either version 2 of the License, or
\     (at your option) any later version.
\
\     This program is distributed in the hope that it will be useful,
\     but WITHOUT ANY WARRANTY; without even the implied warranty of
\     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
\     GNU General Public License for more details.
\
\     You should have received a copy of the GNU General Public License
\     along with this program; if not, write to the Free Software
\     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
\
\ Concepts translated from the a lex & yacc front-end to:
\
\ Ad J. van de Goor, Aad Offerman, and Ivo Schanstra:
\ Towards a Uniform Notation for Memory Tests
\ presented at the European Design & Test Conference and Exhibition 96
\
\ In here you can find a predecessor to the language above that is much more
\ limited (more like an extension to the March test notation) and thus
\ much more cleaner.
\
\ Memory Test Verification and Generation
\  Copyright 1995, A. Offerman (offerman@einstein.et.tudelft.nl),
\                  H.I. Schanstra (ivo@duteca.et.tudelft.nl),
\                  Section Computer Architecture & Digital Systems,
\                  Department of Electrical Engeneering,
\                  Delft University of Technology, The Netherlands
\  All rights reserved
\
\ http://www.offerman.net/memory/mtl.tgz

require ../ffl/stc.fs
require ../Vectors.fth
require ../Structs.fth
require State_mask.fth
require Overlap_constraint.fth
require Position_constraint.fth

struct: Relative_position
        int: x_relative
        int: y_relative
       Flag: placed
;struct

struct: Neighborhood
                         int: height
                         int: width
      Dim2_mirror_constraint field: neighbor_mirror_constraint
    Position_constraint_list: horizontal_position_constraint_list
    Position_constraint_list: vertical_position_constraint_list
     Overlap_constraint_list: neighbor_overlap_constraint_list
                        Flag: word_position_constraint
                  State_mask: shift_mask					\ length B
;struct

: Neighborhood_list:   cell: ;			\ Vector containing Neighborhood(s)

variable left_size
variable right_size

: append_neighborhood_list ( source_neighborhood destination_neighborhood -- )
	swap dup vsize right_size !
	swap dup vsize left_size !
	left_size @ 0 ?do
	    left_size @ right_size @ over + swap ?do
	        dup j [v] horizontal_position_constraint_list i no_constraint vinsert
	        dup j [v] vertical_position_constraint_list i no_constraint vinsert
	        dup j [v] neighbor_overlap_constraint_list i overlap vinsert
	    loop
	loop
	right_size @ 0 ?do
	    dup i left_size @ + 0 vinsert
	    over i [v] over i [v] Neighborhood move
	    left_size @ 0 ?do
	        dup j [v] horizontal_position_constraint_list i no_constraint vinsert
	        dup j [v] vertical_position_constraint_list i no_constraint vinsert
	        dup j [v] neighbor_overlap_constraint_list i overlap vinsert
	    loop
	loop
	2drop
;

: v_complement ( neighborhood_list -- )
	cr ." v_complement @ " . cr
;

: h_complement ( neighborhood_list -- )
	cr ." h_complement @ " . cr
;
