\ Open Memory Test Language parser
\
\ Copyright 2006 Dennis Ruffer (druffer@worldnet.att.net)
\
\     This program is free software; you can redistribute it and/or modify
\     it under the terms of the GNU General Public License as published by
\     the Free Software Foundation; either version 2 of the License, or
\     (at your option) any later version.
\
\     This program is distributed in the hope that it will be useful,
\     but WITHOUT ANY WARRANTY; without even the implied warranty of
\     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
\     GNU General Public License for more details.
\
\     You should have received a copy of the GNU General Public License
\     along with this program; if not, write to the Free Software
\     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
\
\ Concepts translated from the a lex & yacc front-end to:
\
\ Ad J. van de Goor, Aad Offerman, and Ivo Schanstra:
\ Towards a Uniform Notation for Memory Tests
\ presented at the European Design & Test Conference and Exhibition 96
\
\ In here you can find a predecessor to the language above that is much more
\ limited (more like an extension to the March test notation) and thus
\ much more cleaner.
\
\ Memory Test Verification and Generation
\  Copyright 1995, A. Offerman (offerman@einstein.et.tudelft.nl),
\                  H.I. Schanstra (ivo@duteca.et.tudelft.nl),
\                  Section Computer Architecture & Digital Systems,
\                  Department of Electrical Engeneering,
\                  Delft University of Technology, The Netherlands
\  All rights reserved
\
\ http://www.offerman.net/memory/mtl.tgz

variable mtl_variant    0 mtl_variant !     \ 0 = mtla, 1 = mtli, 2 = mtlp

\ mtl_Addressing_direction
    0 constant mtl_up_down
    1 constant mtl_down
    2 constant mtl_up
    3 constant mtl_north_south
    4 constant mtl_south
    5 constant mtl_north
    6 constant mtl_east_west
    7 constant mtl_east
    8 constant mtl_west

\ mtl_Operator
    0 constant mtl_plus
    1 constant mtl_minus

\ MTL interpreter error
variable mtl_error

\ MTL interpreter compute attributes data structures
variable mtla_test
variable mtla_test_current
variable mtla_test_sentinel

variable mtla_horizontal_period
variable mtla_vertical_period
variable mtla_bits_per_word

create mtla_port_type_vector  1 chars 0 vnew ,

\ MTL interpreter preprocessor data structures
variable mtlp_test
variable mtlp_test_current
variable mtlp_test_sentinel

create mtlp_port_type_vector  1 chars 0 vnew ,

variable mtlp_all_ports
variable mtlp_current_port

variable mtlp_reduced_test

\ MTL interpreter expansion data structures
variable mtle_test

variable mtle_updown_dirty_tag
variable mtle_northsouth_dirty_tag
variable mtle_eastwest_dirty_tag
variable mtle_down_south_east_test  0 mtle_down_south_east_test !
variable mtle_up_south_east_test    0 mtle_up_south_east_test !
variable mtle_down_north_east_test  0 mtle_down_north_east_test !
variable mtle_up_north_east_test    0 mtle_up_north_east_test !
variable mtle_down_south_west_test  0 mtle_down_south_west_test !
variable mtle_up_south_west_test    0 mtle_up_south_west_test !
variable mtle_down_north_west_test  0 mtle_down_north_west_test !
variable mtle_up_north_west_test    0 mtle_up_north_west_test !

\ MTL interpreter data structures
variable mtli_test
variable mtli_test_current
variable mtli_test_sentinel

variable mtli_fault_found

\ Variable test pointer references
: mtl_test ( -- a )
    mtl_variant @  0= if  mtla_test  else
    mtl_variant @ 1 = if  mtli_test  else
    mtl_variant @ 2 = if  mtlp_test
    then  then  then
;

: mtl_test_current ( -- a )
    mtl_variant @  0= if  mtla_test_current  else
    mtl_variant @ 1 = if  mtli_test_current  else
    mtl_variant @ 2 = if  mtlp_test_current
    then  then  then
;

: mtl_test_sentinel ( -- a )
    mtl_variant @  0= if  mtla_test_sentinel  else
    mtl_variant @ 1 = if  mtli_test_sentinel  else
    mtl_variant @ 2 = if  mtlp_test_sentinel
    then  then  then
;
