\ MTL Parser based on gforth's Gray version 5
\
\ Copyright 2006 Dennis Ruffer (druffer@worldnet.att.net)
\
\     This program is free software; you can redistribute it and/or modify
\     it under the terms of the GNU General Public License as published by
\     the Free Software Foundation; either version 2 of the License, or
\     (at your option) any later version.
\
\     This program is distributed in the hope that it will be useful,
\     but WITHOUT ANY WARRANTY; without even the implied warranty of
\     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
\     GNU General Public License for more details.
\
\     You should have received a copy of the GNU General Public License
\     along with this program; if not, write to the Free Software
\     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
\

wordlist constant mtlp_wordlist
get-current ( * ) mtlp_wordlist set-current
get-order mtlp_wordlist swap 1+ set-order

: set_port_type_vector ( n -- )   mtlp_port_type_vector dup vsize rot vinsert ;

\ non-terminals

nonterminal <sub_march_element_list>

\ parser

(( <unsigned_integer> )) <- <integer>
(( <unsigned_integer> )) <- <data>

(( <t> (( <integer> )) ?? )) <- <time_operation>

(( <time_operation> )) <- <global_march_element>

(( <integer> )) <- <row_offset>
(( <integer> )) <- <column_offset>

(( <[> <row_offset> <,> <column_offset> <]> )) <- <location>

(( <r> <location> <data>
|| <w> <location> <data>
)) <- <local_operation>

(( <integer> )) <- <number_of_rows>
(( <integer> )) <- <number_of_columns>

(( <[> <number_of_rows> <,> <number_of_columns> <]> )) <- <tile_size>

(( <local_operation> (( <,> <local_operation> )) ** )) <- <local_operation_list>

(( <UPDOWN> || <DOWN> || <UP> )) <- <_1_dimensional_addressing_direction>

(( <EASTWEST> || <EAST> || <WEST> )) <- <row_addressing_direction>

(( <NORTHSOUTH> || <SOUTH> || <NORTH> )) <- <column_addressing_direction>

(( <a> || <b> || <c> || <d> || <e> || <f> || <g> || <h> || <i> || <j> || <k>
|| <l> || <m> || <n> || <o> || <p> || <q> || <r> || <s> || <t> || <u> || <v>
|| <w> || <x> || <y> || <z> )) <- <addressing_id>

(( <addressing_id> (( (( <+> || <-> )) <integer> )) ?? )) <- <addressing_id_offset>

(( <[> <addressing_id_offset> (( <,> <addressing_id_offset> )) ?? <]> )) <- <offset>

(( <r> (( <offset> )) ?? <data>
|| <w> (( <offset> )) ?? <data>
|| <NOP> )) <- <port_operation>

(( <port_operation> (( <:> <port_operation> )) ** )) <- <port_operation_list>

(( <port_operation_list> )) <- <operation>

(( <_1_dimensional_addressing_direction>
||            <row_addressing_direction>
||         <column_addressing_direction> )) <- <addressing_direction>

(( <addressing_direction>
((  (( <-> )) ?? <addressing_id>
(( <=> <->       <addressing_id>
)) ?? )) ?? )) <- <addressing_specifier>

(( <addressing_specifier> <(> <sub_march_element_list> <)>
|| <time_operation> || <operation> )) <- <sub_march_element>

(( <sub_march_element> (( <,> <sub_march_element> )) ** )) <sub_march_element_list> rule

(( <tile_size> <(> <local_operation_list> <)> )) <- <tile_operation>

(( (( <addressing_id> )) ?? <(> <sub_march_element_list> <)>
|| <tile_operation> )) <- <tiled_sub_march_element>

(( <row_addressing_direction>
   (( <addressing_id> )) ?? <(> <sub_march_element_list> <)>
|| <time_operation> )) <- <row_sub_march_element>

(( <row_sub_march_element> (( <,> <row_sub_march_element> )) ** )) <- <row_sub_march_element_list>

(( <row_addressing_direction> <tile_size> <(> <local_operation_list> <)>
)) <- <row_tile_operation>

(( (( <addressing_id> )) ?? <(> <row_sub_march_element_list> <)>
|| <row_tile_operation> )) <- <tiled_row_sub_march_element>

(( <column_addressing_direction>
   (( <addressing_id> )) ?? <(> <sub_march_element_list> <)>
|| <time_operation> )) <- <column_sub_march_element>

(( <column_sub_march_element> (( <,> <column_sub_march_element> )) ** )) <- <column_sub_march_element_list>

(( <column_addressing_direction> <tile_size> <(> <local_operation_list> <)>
)) <- <column_tile_operation>

(( (( <addressing_id> )) ?? <(> <column_sub_march_element_list> <)>
|| <column_tile_operation> )) <- <tiled_column_sub_march_element>

(( <_1_dimensional_addressing_direction>        <tiled_sub_march_element>
||            <row_addressing_direction> <tiled_column_sub_march_element>
||         <column_addressing_direction>    <tiled_row_sub_march_element>
)) <- <normal_march_element>

(( <normal_march_element> || <global_march_element> )) <- <march_element>

(( <march_element> (( <;> <march_element> )) ** )) <- <march_element_list>

(( <{> <march_element_list> <}> )) <- <test_algorithm>

(( <r> {{       read_port set_port_type_vector }}
|| <w> {{      write_port set_port_type_vector }}
|| <x> {{ read_write_port set_port_type_vector }}
|| <-> {{  dont_care_port set_port_type_vector }}
)) ?? <- <port_list>

(( <port_list> || <ALLPORTS> {{ 1 mtlp_all_ports ! }} )) <- <test_type>

(( <test_type> <test_algorithm> )) <- <MTL_test>

( * ) set-current

<MTL_test> parser mtlp

previous

: pparse ( str len )   init  true ?nextsym  mtlp ;
